// *************************************************************
//   Created with BCX -- The BASIC To C Translator (ver 5.11a)
//   BCX (c) 1999 - 2006 by Kevin Diggins
// *************************************************************
//     Translated for compiling with a C Compiler
// *************************************************************
#include <windows.h>    // Win32 Header File 
#include <windowsx.h>   // Win32 Header File 
#include <commctrl.h>   // Win32 Header File 
#include <mmsystem.h>   // Win32 Header File 
#include <shellapi.h>   // Win32 Header File 
#include <shlobj.h>     // Win32 Header File 
#include <richedit.h>   // Win32 Header File 
#include <wchar.h>      // Win32 Header File 
#include <objbase.h>    // Win32 Header File 
#include <ocidl.h>      // Win32 Header File 
#include <winuser.h>    // Win32 Header File 
#include <olectl.h>     // Win32 Header File 
#include <oaidl.h>      // Win32 Header File 
#include <ole2.h>       // Win32 Header File 
#include <oleauto.h>    // Win32 Header File 
#include <conio.h>
#include <direct.h>
#include <ctype.h>
#include <io.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <stdlib.h>
#include <setjmp.h>
#include <time.h>
#include <stdarg.h>
#include <process.h>


// ***************************************************
// Compiler Defines
// ***************************************************

// C++
#if defined( __cplusplus )
  #define overloaded
  #define C_EXPORT EXTERN_C __declspec(dllexport)
  #define C_IMPORT EXTERN_C __declspec(dllimport)
#else
  #define C_EXPORT __declspec(dllexport)
  #define C_IMPORT __declspec(dllimport)
#endif

// Open Watcom defs
#if defined( __WATCOM_CPLUSPLUS__ ) || defined( __TINYC__ )
  #define atanl atan
  #define sinl  sin
  #define cosl  cos
  #define tanl  tan
  #define asinl asin
  #define acosl acos
  #define log10l log10
  #define logl   log
  #define _fcloseall fcloseall
#endif

// Borland C++ 5.5.1 defs - bcc32.exe
#if defined( __BCPLUSPLUS__ )
  // ===== Borland Libraries ==========
  #include <dos.h>
  #pragma comment(lib,"import32.lib")
  #pragma comment(lib,"cw32.lib")
  // ==================================
#endif

// Microsoft VC++
#ifndef DECLSPEC_UUID
  #if (_MSC_VER >= 1100) && defined ( __cplusplus )
    #define DECLSPEC_UUID(x)    __declspec(uuid(x))
  #else
    #define DECLSPEC_UUID(x)
  #endif
#endif


#if !defined( __LCC__ )
// *************************************************
// Instruct Linker to Search Object/Import Libraries
// *************************************************
#pragma comment(lib,"kernel32.lib")
#pragma comment(lib,"user32.lib")
#pragma comment(lib,"gdi32.lib")
#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"advapi32.lib")
#pragma comment(lib,"winspool.lib")
#pragma comment(lib,"shell32.lib")
#pragma comment(lib,"ole32.lib")
#pragma comment(lib,"oleaut32.lib")
#pragma comment(lib,"uuid.lib")
#pragma comment(lib,"odbc32.lib")
#pragma comment(lib,"odbccp32.lib")
#pragma comment(lib,"winmm.lib")
#pragma comment(lib,"comdlg32.lib")
#pragma comment(lib,"imagehlp.lib")
#pragma comment(lib,"version.lib")
#else
#pragma lib <winspool.lib>
#pragma lib <shell32.lib>
#pragma lib <ole32.lib>
#pragma lib <oleaut32.lib>
#pragma lib <uuid.lib>
#pragma lib <odbc32.lib>
#pragma lib <odbccp32.lib>
#pragma lib <winmm.lib>
#pragma lib <imagehlp.lib>
#pragma lib <version.lib>
// *************************************************
// End of Object/Import Libraries To Search
// *************************************************
#endif
// *************************************************
//            User Defined Constants
// *************************************************

#define ENABLE(H) EnableWindow (H ,TRUE )
#define DISABLE(H) EnableWindow (H ,FALSE )

// *************************************************
//                System Variables
// *************************************************

char    CRLF[3]={13,10,0}; // Carr Rtn & Line Feed
HHOOK   CmDlgHook;

// *************************************************
//            User Global Variables
// *************************************************

static HFONT   BcxFont;
static float   BCX_ScaleX;
static float   BCX_ScaleY;
static HINSTANCE BCX_hInstance;
static HWND    BCX_hwndMDIClient;
static WNDCLASSEX   BCX_WndClass;
static BOOL    BCX_GUI_Init;
static char    BCX_ClassName[2048];
static HWND    Form1;
static HWND    Button1;
static HWND    Button2;
static HWND    Button4;
static HWND    Button6;
static HWND    Button7;
static HWND    Button8;
static HWND    Edit1;
static HWND    Edit2;
static HWND    Check1;
static HWND    Inp1;
static HWND    Inp2;
static HWND    List1;
static HWND    List2;
static HWND    List3;
static char    File[2048];
static char    Buffer[2048];
static int     ct;
static int     st;
static int     fsz;
static int     fin;
static int     Index;
static int     nLen;
static char    Ret[2048];
static FILE   *fp1;
static char    dat[5000][2048];
static char    subR[30][2048];
static int     start[30];
static int     fini[30];



// *************************************************
//               Standard Macros
// *************************************************

#define DefaultFont ((BcxFont==0)?GetStockObject(DEFAULT_GUI_FONT):BcxFont)
#define Show(Window)RedrawWindow(Window,0,0,0);ShowWindow(Window,SW_SHOW);
#define VAL(a)(double)atof(a)
#define FINT(a)floor(a)


// *************************************************
//               Standard Prototypes
// *************************************************

void    BCX_SetMetric (char *);
void    BCX_RegWnd (char *, WNDPROC);
void    BCX_InitGUI (void);
int     str_cmp(char*, char*);
int     EoF (FILE*);
HWND    BCX_Form(char*,int=0,int=0,int=250,int=150,int=0,int=0);
HWND    BCX_Edit(char*,HWND,int,int,int,int,int,int=0,int=-1);
HWND    BCX_Input(char*,HWND,int,int,int,int,int,int=0,int=-1);
HWND    BCX_Button(char*,HWND,int=0,int=0,int=0,int=0,int=0,int=0,int=-1);
HWND    BCX_Checkbox(char*,HWND,int=0,int=0,int=0,int=0,int=0,int=0,int=0);
HWND    BCX_Listbox(char*,HWND,int,int,int,int,int,int=0,int=-1);
void    Center (HWND,HWND=0,HWND=0);
void    randomize (unsigned int);
void    swap (char*,char*,int);
char*   BCX_TmpStr(size_t);
char*   mid (char*, int, int=-1);
char*   trim (char*);
char*   space (int a);
char*   str (double);
char*   curdir (void);
LRESULT CALLBACK SBProc (int, WPARAM, LPARAM);
char*    GetFileName (char*,char*,int=0,HWND=0,DWORD=0,char* =0,char* =0,int* =0);
SIZE*   GetTextSize (char*, HWND=0, HFONT=0);
char*   join (int, ... );
int     NumCompareAint (const void *,const void *);
float   rnd (void);
float   timer (void);

// *************************************************
//               User Prototypes
// *************************************************

void    FormLoad (void);
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);
long    EmGetLineCount (int);
char    * GetEditLine (int, int);
char    * EmGetText (int);
long    EmGetTextLength (HWND);
void    GetSubRou (int);
void    FatBoy (void);
void    Mike1 (void);
void    RandGrps (void);
void    MatchSel (void);
void    GetMyFile (void);
void    FindSub (void);
void    MySub (void);
void    Copyit (void);
void    FileSz (void);

// **********************************

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrev,LPSTR CmdLine,int CmdShow)
{
 MSG      Msg;
 strcpy(BCX_ClassName,"BCX_RandDev");
 BCX_SetMetric("");
 BCX_InitGUI();
 BCX_hInstance       =  hInst;
 BCX_WndClass.hIcon  =  LoadIcon(NULL,IDI_WINLOGO);
 BCX_RegWnd( BCX_ClassName, WndProc );


 // ******************************************
                  FormLoad();
 // ******************************************

 while(GetMessage(&Msg,NULL,0,0))
   {
    HWND hActiveWindow = GetActiveWindow();
    if(!IsWindow(hActiveWindow) || !IsDialogMessage(hActiveWindow,&Msg))
      {
        TranslateMessage(&Msg);
        DispatchMessage(&Msg);
      }
    }
 return Msg.wParam;
}


// *************************************************
//                 Runtime Functions
// *************************************************

char *BCX_TmpStr (size_t Bites)
{
  static int   StrCnt;
  static char *StrFunc[2048];
  StrCnt=(StrCnt + 1) & 2047;
  if(StrFunc[StrCnt]) free (StrFunc[StrCnt]);
  return StrFunc[StrCnt]=(char*)calloc(Bites+128,sizeof(char));
}


int str_cmp (char *a, char *b)
{
  register int counter=0;
  while(1)
   {
    if((a[counter]^b[counter]))
     {
      if((UINT) a[counter]>= (UINT) b[counter])
      return  1;
      return -1;
     }
    if(!a[counter]) return 0;
    counter++;
   }
#if !defined( __cplusplus )
 return 0;
#endif
}


int EoF (FILE* stream)
{
  register int c, status = ((c = fgetc(stream)) == EOF);
  ungetc(c,stream);
  return status;
}


char *mid (char *S, int start, int length)
{
  char *strtmp;
  register int tmplen = strlen(S);
  if(start>tmplen||start<1) return BCX_TmpStr(1);
  if (length<0 || length>(tmplen-start)+1)
    length = (tmplen-start)+1;
  strtmp = BCX_TmpStr(length);
  return (char*)memcpy(strtmp,&S[start-1],length*sizeof(char));
}


char *trim (char *S)
{
  while(*S==32 || *S==9 || *S==10 || *S==11 || *S==13)
    S++;
  register int i = strlen(S);
  while( i>0 && (S[i-1]==32 || S[i-1]==9 || S[i-1]==10
             || S[i-1]==11 || S[i-1]==13))
    i--;
  char *strtmp=BCX_TmpStr(i);
  return (char*)memcpy(strtmp,S,i*sizeof(char));
}


char *str (double d)
{
  register char *strtmp = BCX_TmpStr(16);
  sprintf(strtmp,"% .15G",d);
  return strtmp;
}


char *curdir (void)
{
  register char *strtmp = BCX_TmpStr(2048);
  GetCurrentDirectory (1024,strtmp);
  return strtmp;
}


char *space (int count)
{
  if(count<1) return BCX_TmpStr(1);
  register char *strtmp = BCX_TmpStr(count);
  return (char*)memset(strtmp,32,count*sizeof(char));
}


char * join(int n, ...)
{
  register int i = n, tmplen = 0;
  register char *s_;
  register char *strtmp;
  va_list marker;
  va_start(marker, n); // Initialize variable arguments
  while(i-- > 0)
  {
    s_ = va_arg(marker, char *);
    if(s_) tmplen += strlen(s_);
  }
  strtmp = BCX_TmpStr(tmplen);
  va_end(marker); // Reset variable arguments
  i = n;
  va_start(marker, n); // Initialize variable arguments
  while(i-- > 0)
  {
    s_ = va_arg(marker, char *);
    if(s_) strcat(strtmp, s_);
  }
  va_end(marker); // Reset variable arguments
  return strtmp;
}


LRESULT CALLBACK SBProc (int Msg, WPARAM wParam, LPARAM lParam)
{
  if(Msg==HCBT_ACTIVATE)
    {
     static  RECT  rc1;
     static  RECT  rc2;
     GetWindowRect(GetDesktopWindow(),&rc1);
     GetWindowRect((HWND)wParam,&rc2);
     SetWindowPos((HWND)wParam,HWND_TOP,(rc1.left+rc1.right-rc2.right+rc2.left)/2,
     (rc1.top+rc1.bottom-rc2.bottom+rc2.top)/2,0,0,SWP_NOSIZE|SWP_NOACTIVATE);
     UnhookWindowsHookEx(CmDlgHook);
    }
  return 0;
}


char *GetFileName(char *Title,char *Filter,int Flag,HWND hWnd,DWORD Flags,char *InitialDir,char *Initfname,int *ExtIdx)
{
  OPENFILENAME OpenFileStruct;
  char Extension[256];
  int  Counter=0, TmpSize;
  static char *filename;
  static int BufSize;
  TmpSize = ((Flags&OFN_ALLOWMULTISELECT) ? 500000:MAX_PATH);
  if(TmpSize>BufSize)
    {
      BufSize=TmpSize;
      filename=(char*)realloc(filename, BufSize);
    }
  memset(filename,0,BufSize);
  memset(Extension,0,256);
  memset(&OpenFileStruct,0,sizeof(OpenFileStruct));
  if(Initfname) strcpy(filename,Initfname);

  for(Counter=0;Counter<=strlen(Filter);Counter++)
    {
      if(Filter[Counter]=='|')
          Extension[Counter]=0;
      else
          Extension[Counter]=Filter[Counter];
    }
  CmDlgHook=SetWindowsHookEx(WH_CBT,(HOOKPROC)SBProc,(HINSTANCE)NULL,GetCurrentThreadId());
  OpenFileStruct.lStructSize=sizeof(OpenFileStruct);
  OpenFileStruct.hwndOwner=hWnd;
  OpenFileStruct.hInstance=0;
  OpenFileStruct.lpstrFilter=Extension;
  OpenFileStruct.lpstrTitle=Title;
  OpenFileStruct.nMaxFile=BufSize;
  OpenFileStruct.nMaxFileTitle=0;
  OpenFileStruct.lpstrFile=filename;
  OpenFileStruct.lpstrFileTitle=NULL;
  OpenFileStruct.lpstrCustomFilter=0;
  OpenFileStruct.nMaxCustFilter=0;
  if(ExtIdx) OpenFileStruct.nFilterIndex=*ExtIdx;
  OpenFileStruct.lpstrInitialDir=InitialDir;
  OpenFileStruct.nFileOffset=0;
  OpenFileStruct.nFileExtension=0;
  OpenFileStruct.lpstrDefExt=0;
  OpenFileStruct.lCustData=0;
  OpenFileStruct.lpfnHook=0;
  OpenFileStruct.lpTemplateName=0;
  if(!Flags)
      OpenFileStruct.Flags = OFN_HIDEREADONLY | OFN_CREATEPROMPT | OFN_EXPLORER;
  else
      OpenFileStruct.Flags = Flags | OFN_EXPLORER;
  if(!Flag)
    {
      if(GetOpenFileName(&OpenFileStruct)==0)
        {
          *filename=0;
        }else{
          int len=strlen(filename);
          if(filename[len+1]==0) return filename;

          char *fname = filename+len;
          while(fname[1])
            {
              *fname= ',';
              len=strlen(++fname);
              fname+=len;
            }
        }
    }
  else
    {
      if(GetSaveFileName(&OpenFileStruct)==0) *filename=0;
    }
  if(ExtIdx) *ExtIdx=OpenFileStruct.nFilterIndex;
  return filename;
}


float timer (void)
{
  return (GetTickCount()/1000.0);
}


float rnd (void)
{
  return (float)rand()/RAND_MAX;
}


void randomize (unsigned int seed)
{
  srand(seed);
}


void swap ( char* A, char* B, int length)
{
  char t;
  while(length--)
  {
    t = *A;
    *(A++) = *B;
    *(B++) = t;
  }
}


int NumCompareAint (const void *one, const void *two)
{
  int *ptr1 = (int *)(one);
  int *ptr2 = (int *)(two);
  if (*ptr1 < *ptr2) return -1;
  else if (*ptr1 == *ptr2) return 0;
  else return 1;
}


void Center (HWND hwnd, HWND Xhwnd, HWND Yhwnd)
{
  RECT rect, rectP;
  int  x, y, width, height;
  int  screenwidth, screenheight;
  if(Xhwnd==0)
    {
      RECT  DesktopArea;
      RECT  rc;
      SystemParametersInfo(SPI_GETWORKAREA,0,&DesktopArea,0);
      GetWindowRect(hwnd,&rc);
      SetWindowPos(hwnd,HWND_TOP,
        ((DesktopArea.right-DesktopArea.left)-(rc.right-rc.left))/2+
          DesktopArea.left,((DesktopArea.bottom-DesktopArea.top)-
         (rc.bottom-rc.top))/2 + DesktopArea.top,0,0,SWP_NOSIZE);
      return;
    }
  GetWindowRect (hwnd,&rect);
  GetWindowRect (Xhwnd,&rectP);
  width = rect.right-rect.left;
  x = ((rectP.right-rectP.left)-width)/2 + rectP.left;
  if(Yhwnd==NULL)
    {
      height = rect.bottom-rect.top;
      y = ((rectP.bottom-rectP.top)-height)/2 + rectP.top;
    }
  else
    {
      GetWindowRect(Yhwnd,&rectP);
      height = rect.bottom-rect.top;
      y = ((rectP.bottom-rectP.top)-height)/2+rectP.top;
    }
  screenwidth = GetSystemMetrics(SM_CXSCREEN);
  screenheight = GetSystemMetrics(SM_CYSCREEN);
  if ((x<0)) x=0;
  if ((y<0)) y=0;
  if ((x+width>screenwidth))   x = screenwidth-width;
  if ((y+height>screenheight)) y = screenheight-height;
  MoveWindow (hwnd, x, y, width, height, FALSE);
}


HWND BCX_Form(char *Caption,int X,int Y,int W,int H,int Style,int Exstyle)
{
  if(!Style)
    {
       Style= WS_MINIMIZEBOX | WS_SIZEBOX | WS_CAPTION |
              WS_MAXIMIZEBOX | WS_POPUP   | WS_SYSMENU;
    }
  HWND A = CreateWindowEx(Exstyle,BCX_ClassName,Caption,Style,
                          X*BCX_ScaleX,Y*BCX_ScaleY,(4+W)*BCX_ScaleX,(12+H)*BCX_ScaleY,
                          NULL,(HMENU)NULL,BCX_hInstance,NULL);
  SendMessage(A,(UINT)WM_SETFONT,(WPARAM)DefaultFont,(LPARAM)MAKELPARAM(FALSE,0));
  return A;
}


HWND BCX_Button(char* Text,HWND hWnd,int id,int X,int Y,int W,int H,int Style,int Exstyle)
{ 
  if(!Style)
    {
      Style=WS_CHILD | WS_VISIBLE | BS_MULTILINE | BS_PUSHBUTTON | WS_TABSTOP;
    }
  if(Exstyle==-1)
    {
      Exstyle=WS_EX_STATICEDGE;
    }
  HWND A = CreateWindowEx(Exstyle,"button",Text,Style,
                          X*BCX_ScaleX, Y*BCX_ScaleY, W*BCX_ScaleX, H*BCX_ScaleY,
                          hWnd,(HMENU)id,BCX_hInstance,NULL);
  SendMessage(A,(UINT)WM_SETFONT,(WPARAM)DefaultFont,(LPARAM)MAKELPARAM(FALSE,0));
  if (W==0)
    {
      SIZE*  size=GetTextSize(Text,A);
      MoveWindow(A,X*BCX_ScaleX,Y*BCX_ScaleY,size->cx+24,size->cy+12,TRUE);
    }
  return A;
}


HWND BCX_Edit(char* Text,HWND hWnd,int id,int X,int Y,int W,int H,int Style,int Exstyle)
{ 
  HWND  A;
  if(!Style)
    {
      Style = WS_CHILD | WS_VISIBLE | ES_WANTRETURN |
              WS_VSCROLL | ES_MULTILINE | ES_AUTOVSCROLL | ES_AUTOHSCROLL;
    }
  if(Exstyle==-1)
    {
      Exstyle = WS_EX_CLIENTEDGE;
    }
  A = CreateWindowEx(Exstyle,"edit",Text, Style,
      X*BCX_ScaleX, Y*BCX_ScaleY, W*BCX_ScaleX, H*BCX_ScaleY,
      hWnd,(HMENU)id,BCX_hInstance,NULL);
  SendMessage(A,(UINT)WM_SETFONT,(WPARAM)DefaultFont,(LPARAM)MAKELPARAM(FALSE,0));
  return A;
}


HWND BCX_Input(char* Text,HWND hWnd,int id,int X,int Y,int W,int H,int Style,int Exstyle)
{ 
  HWND  A;
  if(!Style)
   {
     Style = WS_CHILD | WS_VISIBLE | WS_TABSTOP | ES_LEFT | ES_AUTOHSCROLL;
   }
  if(Exstyle==-1)
   {
      Exstyle = WS_EX_CLIENTEDGE;
   }
  A = CreateWindowEx(Exstyle,"edit",Text,Style,
      X*BCX_ScaleX, Y*BCX_ScaleY, W*BCX_ScaleX, H*BCX_ScaleY,
      hWnd,(HMENU)id,BCX_hInstance,NULL);
  SendMessage(A,(UINT)WM_SETFONT,(WPARAM)DefaultFont,(LPARAM)MAKELPARAM(FALSE,0));
  return A;
}


HWND BCX_Checkbox(char* Text,HWND hWnd,int id,int X,int Y,int W,int H,int Style,int Exstyle)
{
  HWND  A;
  if(!Style)
    {
      Style=WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX | WS_TABSTOP;
    }
  A = CreateWindowEx(Exstyle,"button",Text,Style,
                     X*BCX_ScaleX, Y*BCX_ScaleY, W*BCX_ScaleX, H*BCX_ScaleY,
                     hWnd,(HMENU)id,BCX_hInstance,NULL);
  SendMessage(A,(UINT)WM_SETFONT,(WPARAM)DefaultFont,(LPARAM)MAKELPARAM(FALSE,0));
  if (W==0)
    {
      SIZE*  size=GetTextSize(Text,A);
      MoveWindow(A,X*BCX_ScaleX,Y*BCX_ScaleY,size->cx+24,size->cy,TRUE);
   }
  return A;
}


HWND BCX_Listbox(char* Text,HWND hWnd,int id,int X,int Y,int W,int H,int Style,int Exstyle)
{ 
  HWND  A;
  if(!Style)
    {
      Style=LBS_STANDARD | WS_CHILD | WS_VISIBLE |
            WS_HSCROLL | WS_VSCROLL | WS_TABSTOP;
    }
  if(Exstyle==-1)
    {
      Exstyle=WS_EX_CLIENTEDGE;
    }
  A = CreateWindowEx(Exstyle,"Listbox",NULL,Style,
                     X*BCX_ScaleX, Y*BCX_ScaleY, W*BCX_ScaleX, H*BCX_ScaleY,
                     hWnd,(HMENU)id,BCX_hInstance,NULL);
  SendMessage(A,(UINT)WM_SETFONT,(WPARAM)DefaultFont,(LPARAM)MAKELPARAM(FALSE,0));
  return A;
}


SIZE* GetTextSize(char* text, HWND hWnd, HFONT fnt)
{
  HDC  hdc=GetDC(hWnd);
  if(!fnt) fnt=(HFONT)SendMessage(hWnd,WM_GETFONT,0,0);
  HFONT sobj=(HFONT)SelectObject(hdc,fnt);
  static SIZE sz;
  GetTextExtentPoint32(hdc,text,strlen(text),&sz);
  SelectObject(hdc,sobj);
  ReleaseDC(hWnd,hdc);
  return (&sz);
}


void BCX_SetMetric (char *metric)
{
  if(!BCX_GUI_Init)
    {
      BCX_InitGUI();
    }
  if(stricmp(metric,"PIXELS")==0)
    {
      BCX_ScaleX=1;
      BCX_ScaleY=1;
    }
  else
    {
      RECT  rc={0,0,4,8};
      MapDialogRect(NULL,&rc);
      BCX_ScaleX=rc.right/2;
      BCX_ScaleY=rc.bottom/4;
    }
}


void BCX_RegWnd (char *classname, WNDPROC Form_WndProc)
{
  if(classname[0]==0)
    {
      MessageBox (GetActiveWindow(),"Empty String For BCX_ClassName NOT Allowed","Empty ClassName",0);
      fflush(stdout);
      ExitProcess(1);
    }
  if(GetClassInfoEx( BCX_hInstance, classname, &BCX_WndClass)!=0)
    {
      if(!Form_WndProc)
        {
          UnregisterClass(classname,BCX_hInstance);
        }
      return;
    }
  if(!BCX_GUI_Init)
    {
      BCX_InitGUI();
    }
  if(BCX_ScaleX==0&&BCX_ScaleY==0)
    {
      BCX_SetMetric("Pixels");
    }
  strcpy(BCX_ClassName,classname);
  BCX_WndClass.lpfnWndProc=Form_WndProc;
  BCX_WndClass.hInstance=BCX_hInstance;
  BCX_WndClass.lpszClassName=classname;
  RegisterClassEx(&BCX_WndClass);
}


void BCX_InitGUI (void)
{
  INITCOMMONCONTROLSEX  iccex;
  if(BCX_GUI_Init)
    {
      return;
    }
  RECT  rc={0,0,4,8};
  MapDialogRect(NULL,&rc);
  BCX_ScaleX=rc.right/2;
  BCX_ScaleY=rc.bottom/4;
  BCX_hInstance=GetModuleHandle(NULL);
  BCX_hwndMDIClient=NULL;
  BCX_WndClass.cbSize=sizeof(BCX_WndClass);
  BCX_WndClass.style=CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
  BCX_WndClass.cbClsExtra=0;
  BCX_WndClass.cbWndExtra=0;
  BCX_WndClass.hIcon= LoadIcon(NULL,IDI_WINLOGO);;
  BCX_WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
  BCX_WndClass.hbrBackground=(HBRUSH)(COLOR_BTNFACE+1);
  BCX_WndClass.lpszMenuName=NULL;
  BCX_WndClass.hIconSm=NULL;
  iccex.dwSize=sizeof(INITCOMMONCONTROLSEX);
  iccex.dwICC=ICC_LISTVIEW_CLASSES | ICC_TREEVIEW_CLASSES | ICC_BAR_CLASSES | ICC_TAB_CLASSES | ICC_UPDOWN_CLASS | ICC_PROGRESS_CLASS | ICC_USEREX_CLASSES | ICC_DATE_CLASSES;
  InitCommonControlsEx(&iccex);
  BCX_GUI_Init=TRUE;
}



// ************************************
//       User Subs and Functions
// ************************************


void FormLoad (void)
{
  Form1=BCX_Form("Random Development",0,0,350,300);
  Edit1=BCX_Edit("",Form1,201,185,5,150,125);
  Edit2=BCX_Edit("",Form1,202,185,135,150,125);
  Button1=BCX_Button("Start",Form1,101,15,230,40,12);
  Button4=BCX_Button("Show Src",Form1,110,15,245,40,12);
  Button2=BCX_Button("Copy",Form1,102,15,260,40,12);
  Button6=BCX_Button("ReSet",Form1,302,15,275,40,12);
  Button8=BCX_Button("BCX IDE",Form1,304,60,230,40,12);
  Button7=BCX_Button("Test Sub",Form1,303,60,245,40,12);
  Check1=BCX_Checkbox("Show Source",Form1,103,60,265,40,5,0);
  Inp1=BCX_Input("",Form1,104,10,2,165,8);
  Inp2=BCX_Input("",Form1,105,10,13,165,8);
  List1=BCX_Listbox("",Form1,106,10,135,80,90,WS_CHILD|WS_VISIBLE|WS_VSCROLL|WS_TABSTOP|LBS_NOTIFY);
  List2=BCX_Listbox("",Form1,107,95,135,80,90,WS_CHILD|WS_VISIBLE|WS_VSCROLL|WS_TABSTOP|LBS_NOTIFY);
  List3=BCX_Listbox("",Form1,108,40,25,100,110,WS_CHILD|WS_VISIBLE|WS_VSCROLL|WS_TABSTOP|LBS_NOTIFY);
  DISABLE(Button4);
  DISABLE(Button7);
  DISABLE(Button8);
  DISABLE(Check1);
  Center(Form1);
  Show(Form1);
}


LRESULT CALLBACK WndProc (HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
  while(1)
  {
    if(LOWORD(wParam)==101)
      {
        SendMessage(List3,(UINT)LB_RESETCONTENT,(WPARAM)0,(LPARAM)0);
        ct=0;
        st=0;
        fin=0;
        GetMyFile();
        SetWindowText(Inp1,join(3,"Program ",File," - Code Snippets"));
        SetWindowText(Inp2,join(4,"Code Snippet Start : ",str(start[Index]),"    Finish =  ",str(fini[Index+1]-1)));
      }
    if(LOWORD(wParam)==102)
      {
        Copyit();
      }
    if(LOWORD(wParam)==103)
      {
        MySub();
        CheckDlgButton(Form1,103,FALSE);
      }
    if(LOWORD(wParam)==108)
      {
        if(HIWORD(wParam)==LBN_SELCHANGE)
          {
            GetSubRou(108);
            return 0;
          }
      }
    if(LOWORD(wParam)==109)
      {
        FileSz();
      }
    if(LOWORD(wParam)==110)
      {
        static int     i;
        memset(&i,0,sizeof(i));
        static char DFile[2048];
        memset(&DFile,0,sizeof(DFile));
        if(File[0]>0)
          {
            if((fp1=fopen(File,"r"))==0)
             {
            fprintf(stderr,"Can't open file %s\n",File);exit(1);
             }
            for(i=0; i<=VAL(str(start[Index]-1)); i+=1)
              {
                ""[0]=0;
                fgets("",1048576,fp1);
                if(""[strlen("")-1]==10)""[strlen("")-1]=0;
              }
            for(i=VAL(str(start[Index])); i<=VAL(str(fini[Index+1]-1)); i+=1)
              {
                dat[i][0]=0;
                fgets(dat[i],1048576,fp1);
                if(dat[i][strlen(dat[i])-1]==10)dat[i][strlen(dat[i])-1]=0;
                strcpy(DFile, join(3,DFile,dat[i],CRLF));
              }
          }
        if(fp1)
         {
           fclose(fp1);
           fp1=NULL;
         }
      }
    if(LOWORD(wParam)==302)
      {
        ct=0;
        st=0;
        fin=0;
        *Ret=0;
        SetWindowText(Edit1,"");
        SendMessage(List1,(UINT)LB_RESETCONTENT,(WPARAM)0,(LPARAM)0);
        SendMessage(List2,(UINT)LB_RESETCONTENT,(WPARAM)0,(LPARAM)0);
        SendMessage(List3,(UINT)LB_RESETCONTENT,(WPARAM)0,(LPARAM)0);
      }
    if(LOWORD(wParam)==303)
      {
      }
    if(LOWORD(wParam)==304)
      {
        static char Editor[2048];
        memset(&Editor,0,sizeof(Editor));
        strcpy(Editor, join(2,curdir(),"\\bcxIDE\\bin\\bcxide.exe"));
        ShellExecute(0,"open",Editor,0,0,1);
      }
    if(Msg==WM_CLOSE)
      {
        DestroyWindow(Form1);
        return 0;
      }
    break;
  }
  if(Msg==WM_DESTROY)
    {
       PostQuitMessage(0);
       return 0;
    }
 return DefWindowProc(hWnd,Msg,wParam,lParam);
}


long EmGetLineCount (int Id)
{
  nLen=SendMessage(Edit1,(UINT)EM_GETLINECOUNT,(WPARAM)0,(LPARAM)0);
}


char * GetEditLine (int Id, int linenum)
{
  char *BCX_RetStr={0};
  WORD*  MaxBuf=(WORD*)Ret;
  *MaxBuf=sizeof(Ret)-1;
  SendMessage(Edit1,(UINT)EM_GETLINE,(WPARAM)linenum,(LPARAM)Ret);
  BCX_RetStr=BCX_TmpStr(strlen(Ret));
  strcpy(BCX_RetStr,Ret);
  return BCX_RetStr;
}


char * EmGetText (int Id)
{
  char *BCX_RetStr={0};
  static  long  nLen;
  memset(&nLen,0,sizeof(nLen));
  HWND  hWnd;
  hWnd=GetDlgItem(Form1,201);
  nLen=EmGetTextLength(Edit1);
  strcpy(Buffer,space(nLen+1));
  GetWindowText(Edit1,Buffer,nLen+1);
  BCX_RetStr=BCX_TmpStr(strlen(Buffer));
  strcpy(BCX_RetStr,Buffer);
  return BCX_RetStr;
}


long EmGetTextLength (HWND Edit1)
{
  return SendMessage(Edit1,(UINT)WM_GETTEXTLENGTH,(WPARAM)0,(LPARAM)0);
}


void GetSubRou (int Id)
{
  HWND  hWnd;
  int     cSel;
  char Buffer[2048];
  cSel=SendMessage(hWnd,(UINT)LB_GETCURSEL,(WPARAM)0,(LPARAM)0);
  strcpy(Buffer,space(255));
  SendMessage(hWnd,(UINT)LB_GETTEXT,(WPARAM)cSel,(LPARAM)Buffer);
  Index=(SendMessage(List3,(UINT)LB_GETCARETINDEX,(WPARAM)0,(LPARAM)0));
  if(Index==0)
    {
      FatBoy();
    }
  else if(Index==1)
    {
      Mike1();
    }
  else if(Index==2)
    {
      RandGrps();
    }
  else if(Index==3)
    {
      MatchSel();
    }
  else if(Index==4)
    {
      GetMyFile();
    }
  else if(Index==5)
    {
      FindSub();
    }
  else if(Index==6)
    {
      MySub();
    }
  else if(Index==7)
    {
      Copyit();
    }
  SetWindowText(Inp1,join(4,"Program ",File," - Code Snippet #",str(Index+1)));
  SetWindowText(Inp2,join(4,"Code Snippet Start : ",str(start[Index]),"    Finish =  ",str(fini[Index+1]-1)));
  MySub();
}


void FatBoy (void)
{
  static int     i;
  memset(&i,0,sizeof(i));
  static int     j;
  memset(&j,0,sizeof(j));
  static char all[20][2048];
  memset(&all,0,sizeof(all));
  static int     k[50];
  memset(&k,0,sizeof(k));
  static char sorted[2048];
  memset(&sorted,0,sizeof(sorted));
  static int     slot[200];
  memset(&slot,0,sizeof(slot));
  static int     pick;
  memset(&pick,0,sizeof(pick));
  static int     a;
  memset(&a,0,sizeof(a));
  static int     b;
  memset(&b,0,sizeof(b));
  static int     c;
  memset(&c,0,sizeof(c));
  if(IsDlgButtonChecked(Form1,103)==FALSE)
    {
      SendMessage(List1,(UINT)LB_RESETCONTENT,(WPARAM)0,(LPARAM)0);
    }
  for(i=0; i<=200; i+=1)
    {
      slot[i]=0;
    }
  if(IsDlgButtonChecked(Form1,103)==FALSE)
    {
      a=0;
      b=0;
    }
  else
    {
      a=8;
      b=5;
    }
  randomize(timer());
  for(j=(0+b); j<=(10+b); j+=1)
    {
      for(i=1; i<=36; i+=1)
        {
          k[i]=i;
        }
      for(i=1; i<=36; i+=1)
        {
          swap ((char*)&k[(int)FINT(rnd()*37)],(char*)&k[(int)FINT(rnd()*37)],sizeof(k[(int)FINT(rnd()*37)]));
        }
      qsort(k,6,sizeof(int),NumCompareAint);
      for(i=1; i<=5; i+=1)
        {
          if(strlen(trim(str(k[i])))<2)
            {
              strcpy(sorted, join(4,sorted,"0",trim(str(k[i]))," "));
            }
          else
            {
              strcpy(sorted, join(3,sorted,trim(str(k[i]))," "));
            }
        }
      strcpy(all[j],sorted);
      *sorted=0;
    }
  for(i=(0+b); i<=(10+b); i+=1)
    {
      SendMessage(List1,(UINT)LB_ADDSTRING,(WPARAM)0,(LPARAM)all[i]);
      strcpy(all[i],all[i]);
    }
}


void Mike1 (void)
{
  randomize(timer());
  int     q;
  int     j;
  int     aMax;
  int     Slot[6];
  char tmp[6][2048];
  char sets[2048];
  aMax=6;
  strcpy(tmp[0],"05");
  strcpy(tmp[1],"07");
  strcpy(tmp[2],"12");
  strcpy(tmp[3],"22");
  strcpy(tmp[4],"35");
  strcpy(tmp[5],"42");
  SendMessage(List1,(UINT)LB_RESETCONTENT,(WPARAM)0,(LPARAM)0);
  for(q=0; q<=5; q+=1)
    {
      Slot[q]=VAL(tmp[q]);
    }
  for(q=0; q<=5; q+=1)
    {
      j=q+FINT((aMax-q)*rnd());
      if(j<q)
        {
          swap ((char*)&Slot[j],(char*)&Slot[q],sizeof(Slot[q]));
        }
      strcpy(sets, join(3,sets,str(Slot[q])," "));
    }
  SendMessage(List1,(UINT)LB_ADDSTRING,(WPARAM)0,(LPARAM)sets);
}


void RandGrps (void)
{
  static int     i;
  memset(&i,0,sizeof(i));
  static int     j;
  memset(&j,0,sizeof(j));
  static char all[20][2048];
  memset(&all,0,sizeof(all));
  static int     k[50];
  memset(&k,0,sizeof(k));
  static char sorted[20][2048];
  memset(&sorted,0,sizeof(sorted));
  static int     slot[200];
  memset(&slot,0,sizeof(slot));
  static int     pick;
  memset(&pick,0,sizeof(pick));
  static int     mix;
  memset(&mix,0,sizeof(mix));
  static char tmp[10][2048];
  memset(&tmp,0,sizeof(tmp));
  static int     a;
  memset(&a,0,sizeof(a));
  static int     b;
  memset(&b,0,sizeof(b));
  static int     c;
  memset(&c,0,sizeof(c));
  static int     d;
  memset(&d,0,sizeof(d));
  mix=44;
  strcpy(tmp[0],"5");
  strcpy(tmp[1],"7");
  strcpy(tmp[2],"12");
  strcpy(tmp[3],"22");
  strcpy(tmp[4],"35");
  strcpy(tmp[5],"42");
  SendMessage(List1,(UINT)LB_RESETCONTENT,(WPARAM)0,(LPARAM)0);
  for(i=0; i<=200; i+=1)
    {
      slot[i]=0;
    }
  randomize(timer());
  for(c=0; c<=1; c+=1)
    {
      for(j=(0+b); j<=(4+b); j+=1)
        {
          for(i=1; i<=4; i+=1)
            {

CHOOSE:;
              pick=FINT(rnd()*mix)+1;
              if((slot[pick]==1))
                {
                  goto CHOOSE;
                }
              if(j>5)
                {
                  for(d=0; d<=3; d+=1)
                    {
                      if(pick==VAL(tmp[d]))
                        {
                          slot[pick]=1;
                          goto CHOOSE;
                        }
                    }
                }
              k[i]=pick;
              slot[pick]=1;
            }
          qsort(k,5,sizeof(int),NumCompareAint);
          for(i=1; i<=4; i+=1)
            {
              if(strlen(trim(str(k[i])))<2)
                {
                  strcpy(sorted[j], join(4,sorted[j],"0",trim(str(k[i]))," "));
                }
              else
                {
                  strcpy(sorted[j], join(3,sorted[j],trim(str(k[i]))," "));
                }
            }
        }
      for(i=(0+b); i<=(4+b); i+=1)
        {
          SendMessage(List1,(UINT)LB_ADDSTRING,(WPARAM)0,(LPARAM)sorted[i]);
        }
      for(i=0; i<=10; i+=1)
        {
          *sorted[i]=0;
        }
      b+=5;
      for(i=0; i<=200; i+=1)
        {
          slot[i]=0;
        }
      SendMessage(List1,(UINT)LB_ADDSTRING,(WPARAM)0,(LPARAM)"");
    }
}


void MatchSel (void)
{
  static int     i;
  memset(&i,0,sizeof(i));
  static int     j;
  memset(&j,0,sizeof(j));
  static char all[20][2048];
  memset(&all,0,sizeof(all));
  static int     k[50];
  memset(&k,0,sizeof(k));
  static char sorted[20][2048];
  memset(&sorted,0,sizeof(sorted));
  static int     slot[200];
  memset(&slot,0,sizeof(slot));
  static int     pick;
  memset(&pick,0,sizeof(pick));
  static int     mix;
  memset(&mix,0,sizeof(mix));
  static char tmp[10][2048];
  memset(&tmp,0,sizeof(tmp));
  static char current[2048];
  memset(&current,0,sizeof(current));
  static char random[2048];
  memset(&random,0,sizeof(random));
  static int     match;
  memset(&match,0,sizeof(match));
  static int     a;
  memset(&a,0,sizeof(a));
  static int     b;
  memset(&b,0,sizeof(b));
  static int     c;
  memset(&c,0,sizeof(c));
  static int     d;
  memset(&d,0,sizeof(d));
  static char found[2048];
  memset(&found,0,sizeof(found));
  static char user[2048];
  memset(&user,0,sizeof(user));
  SendMessage(List1,(UINT)LB_RESETCONTENT,(WPARAM)0,(LPARAM)0);
  SendMessage(List2,(UINT)LB_RESETCONTENT,(WPARAM)0,(LPARAM)0);
  mix=36;
  strcpy(current,"05 07 12 22 35");
  for(i=0; i<=50; i+=1)
    {
      k[i]=0;
    }
  for(i=0; i<=200; i+=1)
    {
      slot[i]=0;
    }
  randomize(timer());
  for(d=0; d<=5; d+=1)
    {
      SendMessage(List1,(UINT)LB_RESETCONTENT,(WPARAM)0,(LPARAM)0);
      SendMessage(List1,(UINT)LB_ADDSTRING,(WPARAM)0,(LPARAM)"Input to Match");
      SendMessage(List1,(UINT)LB_ADDSTRING,(WPARAM)0,(LPARAM)current);
      SendMessage(List1,(UINT)LB_ADDSTRING,(WPARAM)0,(LPARAM)"");
      for(i=0; i<=4; i+=1)
        {

CHOOSE:;
          pick=FINT(rnd()*mix)+1;
          if((slot[pick]==1))
            {
              goto CHOOSE;
            }
          k[i]=pick;
          slot[pick]=1;
        }
      for(i=0; i<=200; i+=1)
        {
          slot[i]=0;
        }
      qsort(k,6,sizeof(int),NumCompareAint);
      for(i=1; i<=5; i+=1)
        {
          if(strlen(trim(str(k[i])))<2)
            {
              strcpy(random, join(4,random,"0",trim(str(k[i]))," "));
            }
          else
            {
              strcpy(random, join(3,random,trim(str(k[i]))," "));
            }
        }
      SendMessage(List1,(UINT)LB_ADDSTRING,(WPARAM)0,(LPARAM)"Numbers to Match");
      SendMessage(List1,(UINT)LB_ADDSTRING,(WPARAM)0,(LPARAM)random);
      for(j=0; j<=4; j+=1)
        {
          for(i=0; i<=4; i+=1)
            {
              if(str_cmp(mid(current,1+c,3),mid(random,1+b,3))==0)
                {
                  match=1+a;
                  a++;
                  if(match>=2)
                    {
                      strcpy(user, join(3,user,str(j+1),","));
                      SendMessage(List2,(UINT)LB_ADDSTRING,(WPARAM)0,(LPARAM)join(2,"Loop # ",str(d+1)));
                      SendMessage(List2,(UINT)LB_ADDSTRING,(WPARAM)0,(LPARAM)join(4,"User#",user,"= ",random));
                    }
                }
              else
                {
                }
              b+=3;
            }
          b=0;
          c+=3;
        }
      SendMessage(List1,(UINT)LB_ADDSTRING,(WPARAM)0,(LPARAM)"");
      SendMessage(List1,(UINT)LB_ADDSTRING,(WPARAM)0,(LPARAM)"Number of Matches");
      SendMessage(List1,(UINT)LB_ADDSTRING,(WPARAM)0,(LPARAM)join(2,"Match = ",str(match)));
      b=0;
      c=0;
      match=0;
      *random=0;
      *user=0;
    }
  SendMessage(List1,(UINT)LB_ADDSTRING,(WPARAM)0,(LPARAM)join(2,"No. of Tests=",str(d-1)));
}


void GetMyFile (void)
{
  static int     i;
  memset(&i,0,sizeof(i));
  static char CurPath[2048];
  memset(&CurPath,0,sizeof(CurPath));
  static int     Fsize;
  memset(&Fsize,0,sizeof(Fsize));
  static char Mask[2048];
  memset(&Mask,0,sizeof(Mask));
  static int     ctl;
  memset(&ctl,0,sizeof(ctl));
  static char tmp[2048];
  memset(&tmp,0,sizeof(tmp));
  SendMessage(List2,(UINT)LB_RESETCONTENT,(WPARAM)0,(LPARAM)0);
  strcat(Mask,"All Files (*.*)|*.*|");
  strcpy(File,GetFileName("OPEN",Mask,0));
  if(File[0]>0)
    {
      if((fp1=fopen(File,"r"))==0)
       {
      fprintf(stderr,"Can't open file %s\n",File);exit(1);
       }
      while(!EoF(fp1))
        {
          dat[ctl][0]=0;
          fgets(dat[ctl],1048576,fp1);
          if(dat[ctl][strlen(dat[ctl])-1]==10)dat[ctl][strlen(dat[ctl])-1]=0;
          FindSub();
          ctl++;
        }
      if(fp1)
       {
         fclose(fp1);
         fp1=NULL;
       }
    }
}


void FindSub (void)
{
  static int     a;
  memset(&a,0,sizeof(a));
  static int     b;
  memset(&b,0,sizeof(b));
  static int     c;
  memset(&c,0,sizeof(c));
  static int     d;
  memset(&d,0,sizeof(d));
  static int     i;
  memset(&i,0,sizeof(i));
  static char fnd[2048];
  memset(&fnd,0,sizeof(fnd));
  static char tmp[2048];
  memset(&tmp,0,sizeof(tmp));
  b=1;
  d=b+4;
  strcpy(tmp,mid(dat[ct],1,3));
  start[st]=ct;
  fini[fin]=start[st];
  if(str_cmp(tmp,"Sub")==0)
    {
      if(d==5)
        {
          strcpy(fnd,mid(dat[ct],d,strlen(dat[ct])-1));
          strcpy(subR[st],fnd);
          SendMessage(List3,(UINT)LB_ADDSTRING,(WPARAM)0,(LPARAM)join(2,"Code for :  ",subR[st]));
          *tmp=0;
          *fnd=0;
          st++;
          fin++;
        }
      else
        {
          *tmp=0;
          *Ret=0;
        }
    }
  ct++;
}


void MySub (void)
{
  static int     i;
  memset(&i,0,sizeof(i));
  static char DFile[2048];
  memset(&DFile,0,sizeof(DFile));
  if(File[0]>0)
    {
      if((fp1=fopen(File,"r"))==0)
       {
      fprintf(stderr,"Can't open file %s\n",File);exit(1);
       }
      for(i=0; i<=VAL(str(start[Index]-1)); i+=1)
        {
          ""[0]=0;
          fgets("",1048576,fp1);
          if(""[strlen("")-1]==10)""[strlen("")-1]=0;
        }
      for(i=VAL(str(start[Index])); i<=VAL(str(fini[Index+1]-2)); i+=1)
        {
          dat[i][0]=0;
          fgets(dat[i],1048576,fp1);
          if(dat[i][strlen(dat[i])-1]==10)dat[i][strlen(dat[i])-1]=0;
          strcpy(DFile, join(3,DFile,dat[i],CRLF));
        }
    }
  if(fp1)
   {
     fclose(fp1);
     fp1=NULL;
   }
  SetWindowText(Edit1,DFile);
  EmGetLineCount(201);
}


void Copyit (void)
{
  SendMessage(Edit1,(UINT)EM_SETSEL,(WPARAM)0,(LPARAM)-1);
  SendMessage(Edit1,(UINT)WM_COPY,(WPARAM)0,(LPARAM)0);
  SendMessage(Edit1,(UINT)EM_SETSEL,(WPARAM)-1,(LPARAM)0);
  MessageBox (GetActiveWindow(),"Code snippet has been saved to the clipboard."," ",MB_OK|MB_ICONINFORMATION);
}


void FileSz (void)
{
  static char foo[2000][2048];
  memset(&foo,0,sizeof(foo));
  static char Mask[2048];
  memset(&Mask,0,sizeof(Mask));
  strcat(Mask,"All Files (*.*)|*.*|");
  strcpy(File,GetFileName("OPEN",Mask,0));
  if(File[0]>0)
    {
      if((fp1=fopen(File,"r"))==0)
       {
      fprintf(stderr,"Can't open file %s\n",File);exit(1);
       }
      while(!EoF(fp1))
        {
          foo[fsz][0]=0;
          fgets(foo[fsz],1048576,fp1);
          if(foo[fsz][strlen(foo[fsz])-1]==10)foo[fsz][strlen(foo[fsz])-1]=0;
          fsz++;
        }
      if(fp1)
       {
         fclose(fp1);
         fp1=NULL;
       }
    }
  SetWindowText(Inp1,join(3,File," File size is: ",str(fsz)));
}


